Download aggregated usage data as a CSV. - m3ter Documentation

Documentation Index

Fetch the complete documentation index at: /llms.txt

Use this file to discover all available pages before exploring further.

Download aggregated usage data as a CSV.

cURL

curl --request POST \
  --url https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "meterCodes": [\
    "<string>"\
  ],
  "startDate": "2023-11-07T05:31:56Z",
  "endDate": "2023-11-07T05:31:56Z",
  "aggregationFrequency": "<unknown>",
  "measures": [\
    {\
      "name": "<string>",\
      "aggregations": []\
    }\
  ],
  "version": 123,
  "dimensions": [\
    {\
      "name": "<string>",\
      "filter": [\
        "<string>"\
      ],\
      "attributes": [\
        "<string>"\
      ]\
    }\
  ],
  "limit": 2500
}
'

Python

import requests

url = "https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv"

payload = {
    "meterCodes": ["<string>"],
    "startDate": "2023-11-07T05:31:56Z",
    "endDate": "2023-11-07T05:31:56Z",
    "aggregationFrequency": "<unknown>",
    "measures": [\
        {\
            "name": "<string>",\
            "aggregations": []\
        }\
    ],
    "version": 123,
    "dimensions": [\
        {\
            "name": "<string>",\
            "filter": ["<string>"],\
            "attributes": ["<string>"]\
        }\
    ],
    "limit": 2500
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    meterCodes: ['<string>'],
    startDate: '2023-11-07T05:31:56Z',
    endDate: '2023-11-07T05:31:56Z',
    aggregationFrequency: '<unknown>',
    measures: [{name: '<string>', aggregations: []}],
    version: 123,
    dimensions: [{name: '<string>', filter: ['<string>'], attributes: ['<string>']}],
    limit: 2500
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    'meterCodes' => [\
        '<string>'\
    ],\
    'startDate' => '2023-11-07T05:31:56Z',\
    'endDate' => '2023-11-07T05:31:56Z',\
    'aggregationFrequency' => '<unknown>',\
    'measures' => [\
        [\
                'name' => '<string>',\
                'aggregations' => [\
\
                ]\
        ]\
    ],\
    'version' => 123,\
    'dimensions' => [\
        [\
                'name' => '<string>',\
                'filter' => [\
                                '<string>'\
                ],\
                'attributes' => [\
                                '<string>'\
                ]\
        ]\
    ],\
    'limit' => 2500\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv"

payload := strings.NewReader("{\n  \"meterCodes\": [\n    \"<string>\"\n  ],\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"aggregationFrequency\": \"<unknown>\",\n  \"measures\": [\n    {\n      \"name\": \"<string>\",\n      \"aggregations\": []\n    }\n  ],\n  \"version\": 123,\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 2500\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Unirest Java

HttpResponse<String> response = Unirest.post("https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"meterCodes\": [\n    \"<string>\"\n  ],\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"aggregationFrequency\": \"<unknown>\",\n  \"measures\": [\n    {\n      \"name\": \"<string>\",\n      \"aggregations\": []\n    }\n  ],\n  \"version\": 123,\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 2500\n}")
  .asString();

Ruby

require 'uri'
require 'net/http'

url = URI("https://api.m3ter.com/organizations/{orgId}/dataexplorer/usagedata/download/csv")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"meterCodes\": [\n    \"<string>\"\n  ],\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"aggregationFrequency\": \"<unknown>\",\n  \"measures\": [\n    {\n      \"name\": \"<string>\",\n      \"aggregations\": []\n    }\n  ],\n  \"version\": 123,\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 2500\n}"

response = http.request(request)
puts response.read_body

Response Codes

Sample JSON Response

{
  "downloadUrl": "<string>"
}

Authorizations

Authorization is required as a header. Use clientCredentials OAuth2 flow for machine-to-machine authentication.